;
; sse_mult_su3_mat_vec( su3_matrix *a, su3_vector *b, su3_vector *c)
;

global sse_mult_su3_mat_vec
sse_mult_su3_mat_vec:
;	push		ebp
;	mov		ebp,esp
;	mov		eax,[ebp+8]			; su3_matrix *a
;	mov		ebx,[ebp+12]			; su3_vector *b
;	mov		ecx,[ebp+16]			; su3_vector *c

	;  bring in real and imaginary b vector
;	movups		xmm0,[ebx+8]			; c1r,c1i,c2r,c2i
;	movaps		xmm1,xmm0
;	movups		xmm7,[ebx]			; in case unaligned
;	shufps		xmm0,xmm7,0x02			; c2r,c1r,c0r,c0r
;	shufps		xmm1,xmm7,0x57			; c2i,c1i,c0i,c0i

	;  bring in real and imaginary a[0] vector
;	movups		xmm2,[eax+8]			; c1r,c1i,c2r,c2i
;	movaps		xmm3,xmm2
;	movups		xmm7,[eax]			; in case unaligned
;	shufps		xmm2,xmm7,0x02			; c2r,c1r,c0r,c0r
;	shufps		xmm3,xmm7,0x57			; c2i,c1i,c0i,c0i

	;  xmm0=real(b)  xmm1=imag(b)   xmm2=real(a[0])  xmm3=imag(a[0])
;	movaps		xmm4,xmm2
	mulps		xmm4,xmm0			; real.a[0] x real.b
;	movaps		xmm5,xmm3
	mulps		xmm5,xmm1			; imag.a[0] x imag.b
	subps		xmm4,xmm5			; realxreal - imagximag
	mulps		xmm2,xmm1			; real.a[0] x imag.b
	mulps		xmm3,xmm0			; imag.a[0] x real.b
	addps		xmm3,xmm2			; realximag + imagxreal

	;  xmm4=real unsummed, xmm3=imag unsummed.  Must pivot and sum.
;	movaps		xmm5,xmm4
;	unpcklps	xmm5,xmm3			; c2r,c2i,c1r,c1i
;	shufps		xmm2,xmm5,0x4b			; x,  x,  c2r,c2i
;	movaps		xmm7,xmm4
;	unpckhps	xmm7,xmm3			; c0r,c0i,c0r,c0i
	addps		xmm7,xmm2			; add in  c2r,c2i
	addps		xmm7,xmm5			; add in  c1r,c1i
;	movhps		[ecx],xmm7			; stash the result

	;  bring in real and imaginary a[1] vector
;	movups		xmm2,[eax+32]			; c1r,c1i,c2r,c2i
;	movaps		xmm3,xmm2
;	movups		xmm7,[eax+24]			; in case unaligned
;	shufps		xmm2,xmm7,0x02			; c2r,c1r,c0r,c0r
;	shufps		xmm3,xmm7,0x57			; c2i,c1i,c0i,c0i

	;  xmm0=real(b)  xmm1=imag(b)   xmm2=real(a[1])  xmm3=imag(a[1])
;	movaps		xmm4,xmm2
	mulps		xmm4,xmm0			; real.a[0] x real.b
;	movaps		xmm5,xmm3
	mulps		xmm5,xmm1			; imag.a[0] x imag.b
	subps		xmm4,xmm5			; realxreal - imagximag
	mulps		xmm2,xmm1			; real.a[0] x imag.b
	mulps		xmm3,xmm0			; imag.a[0] x real.b
	addps		xmm3,xmm2			; realximag + imagxreal

	;  xmm4=real unsummed, xmm3=imag unsummed.  Must pivot and sum.
;	movaps		xmm5,xmm4
;	unpcklps	xmm5,xmm3			; c2r,c2i,c1r,c1i
;	shufps		xmm2,xmm5,0x4b			; x,  x,  c2r,c2i
;	movaps		xmm7,xmm4
;	unpckhps	xmm7,xmm3			; c0r,c0i,c0r,c0i
	addps		xmm7,xmm2			; add in  c2r,c2i
	addps		xmm7,xmm5			; add in  c1r,c1i
;	movhps		[ecx+8],xmm7			; stash the result

	;  bring in real and imaginary a[2] vector
;	movups		xmm2,[eax+56]			; c1r,c1i,c2r,c2i
;	movaps		xmm3,xmm2
;	movups		xmm7,[eax+48]			; in case unaligned
;	shufps		xmm2,xmm7,0x02			; c2r,c1r,c0r,c0r
;	shufps		xmm3,xmm7,0x57			; c2i,c1i,c0i,c0i

	;  xmm0=real(b)  xmm1=imag(b)   xmm2=real(a[2])  xmm3=imag(a[2])
;	movaps		xmm4,xmm2
	mulps		xmm4,xmm0			; real.a[0] x real.b
;	movaps		xmm5,xmm3
	mulps		xmm5,xmm1			; imag.a[0] x imag.b
	subps		xmm4,xmm5			; realxreal - imagximag
	mulps		xmm2,xmm1			; real.a[0] x imag.b
	mulps		xmm3,xmm0			; imag.a[0] x real.b
	addps		xmm3,xmm2			; realximag + imagxreal

	;  xmm4=real unsummed, xmm3=imag unsummed.  Must pivot and sum.
;	movaps		xmm5,xmm4
;	unpcklps	xmm5,xmm3			; c2r,c2i,c1r,c1i
;	shufps		xmm2,xmm5,0x4b			; x,  x,  c2r,c2i
;	movaps		xmm7,xmm4
;	unpckhps	xmm7,xmm3			; c0r,c0i,c0r,c0i
	addps		xmm7,xmm2			; add in  c2r,c2i
	addps		xmm7,xmm5			; add in  c1r,c1i
;	movhps		[ecx+16],xmm7			; stash the result

here:
;	mov	esp,ebp
;	pop	ebp
	ret
	
