;
; sse_scalar_mult_add_su3_matrix( su3_matrix *a, su3_matrix *b, float s, su3_matrix *c)
;
; C  <--  A + s*B  

global sse_scalar_mult_add_su3_matrix
sse_scalar_mult_add_su3_matrix:
	push		ebp
	mov		ebp,esp
	push		eax
	push		ebx
	push		ecx
	mov		eax,[ebp+8]			; su3_matrix *a
	mov		ebx,[ebp+12]			; su3_matrix *b
	mov		ecx,[ebp+20]			; su3_vector *c

	; get scalar value, s
	movss		xmm0,[ebp+16]			; float s
	shufps		xmm0,xmm0,0x00			; s, s, s, s

	; process (1,1) and (1,2)
	movups		xmm1,[eax]			; c1i,c1r,c0i,c0r
	movups		xmm2,[ebx]			; c1i,c1r,c0i,c0r
	mulps		xmm2,xmm0			; s*[c1i,c1r,c0i,c0r]
	addps		xmm2,xmm1			; a + s*b
	movups		[ecx],xmm2

	; process (1,3) and (2,1)
	movups		xmm1,[eax+16]			; c1i,c1r,c0i,c0r
	movups		xmm2,[ebx+16]			; c1i,c1r,c0i,c0r
	mulps		xmm2,xmm0			; s*[c1i,c1r,c0i,c0r]
	addps		xmm2,xmm1			; a + s*b
	movups		[ecx+16],xmm2
	
	; process (2,2) and (2,3)
	movups		xmm1,[eax+32]			; c1i,c1r,c0i,c0r
	movups		xmm2,[ebx+32]			; c1i,c1r,c0i,c0r
	mulps		xmm2,xmm0			; s*[c1i,c1r,c0i,c0r]
	addps		xmm2,xmm1			; a + s*b
	movups		[ecx+32],xmm2
	
	; process (3,1) and (3,2)
	movups		xmm1,[eax+48]			; c1i,c1r,c0i,c0r
	movups		xmm2,[ebx+48]			; c1i,c1r,c0i,c0r
	mulps		xmm2,xmm0			; s*[c1i,c1r,c0i,c0r]
	addps		xmm2,xmm1			; a + s*b
	movups		[ecx+48],xmm2
	
	; process (3,2) and (3,3)
	movlps		xmm1,[eax+64]			; c1i,c1r,c0i,c0r
	movlps		xmm2,[ebx+64]			; c1i,c1r,c0i,c0r
	mulps		xmm2,xmm0			; s*[c1i,c1r,c0i,c0r]
	addps		xmm2,xmm1			; a + s*b
	movlps		[ecx+64],xmm2

here:	pop	ecx
	pop	ebx
	pop	eax
	mov	esp,ebp
	pop	ebp
	ret
	
