/* time subroutine call overheads */
#include "complex.h"
#include "su3.h"
#include <stdio.h>
#include <stdlib.h>
#include <sched.h>
#include <error.h>
#include <asm/msr.h>
#include <fcntl.h>
#include <unistd.h>

void sse_blank(void);

int main(int argc, char **argv)
{
  int i,iter=1;
  struct sched_param param={sched_priority:20};
  volatile unsigned long long timeA, timeSSE;
  unsigned int seed=1;
  int randomfd;
  
  if ((randomfd=open("/dev/urandom", O_RDONLY)) < 0)
    perror("Attempt to open /dev/urandom");
  if (read(randomfd, &seed, sizeof(seed)) < sizeof(seed))
    perror("Attempt to read /dev/urandom");
  close(randomfd);
  srand(seed);

  if (sched_setscheduler(0, SCHED_FIFO, &param) < 0)
    perror("Attempt to put in real time queue");

  if (argc > 1) sscanf(argv[1],"%d",&iter);
  
  rdtscll(timeA);
  for (i=0; i<iter; i++) {
    sse_blank();
  }
  rdtscll(timeSSE);
  timeSSE -= timeA;

  printf("Time per iteration: %Lu\n", timeSSE/(unsigned long long)iter);

  exit(0);
}


    
